import isValidDomain from 'is-valid-domain';
import type { BasicRule } from './rules/utils';
import { RequestRule } from './rules/RequestRule';
import { NoFilteringRule } from './rules/NoFilteringRule';
import { Comment } from './rules/Comment';
import { CustomRule } from './rules/CustomRule';
type RuleType = 'block' | 'unblock' | 'noFiltering' | 'custom' | 'comment';
type DomainValidationOptions = Parameters<typeof isValidDomain>[1];
export declare class RulesBuilder {
    static getRuleByType(type: 'block'): RequestRule;
    static getRuleByType(type: 'unblock'): RequestRule;
    static getRuleByType(type: 'noFiltering'): NoFilteringRule;
    static getRuleByType(type: 'custom'): CustomRule;
    static getRuleByType(type: 'comment'): Comment;
    static validateDomain(ruleBuilder: RequestRule | NoFilteringRule, opts?: DomainValidationOptions): boolean;
    static validateRule(ruleBuilder: BasicRule): boolean;
    static getRuleType(rawRule: string): RuleType | null;
    static getRuleFromRuleString(rawRule: string): RequestRule | NoFilteringRule | CustomRule | Comment | null;
}
export {};
